import utilities as ut
import os


def get_platform_size(name, path):
    count = 0
    f = open(str(path + name + "/" + name + "_platform.txt"), "r")
    for line in f:
        count += 1
    f.close()
    return count


#29.11.19 endret fra å ta inn size = fp.get_platform_size(filepath, filename) utenfor
def load_file(mode, filename, filepath):
    if mode == 2:
        print("Loading 2D file")
        return load_file_2D(filename, filepath)
    if mode == 3:
        print("Loading 3D file")
        size = get_platform_size(filename, filepath)
        return load_file_3D(filename, filepath, size)
    else:
        print("Wrong dims-value, only 2D an 3D accepted")


def load_file_2D(filename, filepath):
    complete_path = str(filepath+filename+".txt")
    dimx, dimy = ut.get_dimensions(complete_path)
    size = dimy-1
    #p = load_platform_2D(complete_path, size)
    #m = load_object_2D(complete_path, size)
    #return m,p
    return load_object_2D(complete_path, size), load_platform_2D(complete_path, size)


#Returnerer koordinatene til objektet som 2D-list
def load_object_2D(filename,numLines):
    file = open(filename, "r")
    a = []

    for i, row in enumerate(file):
        for j, elem in enumerate(row):
            coords = []
            if elem == '1':
                # mapping av verdier til cart-coordinater
                coords.append(j + 1)
                coords.append(-i + numLines)
                a.append(coords)

    file.close()
    return a

#Returnerer koordinatene til platformen som 2D-list
def load_platform_2D(filename, numLines):
    file = open(filename, "r")
    a = []

    for i, row in enumerate(file):
        for j, elem in enumerate(row):
            coords = []
            if elem == '-':
                # mapping av verdier til cart-coordinater
                coords.append(j + 1)
                coords.append(-i + numLines)
                a.append(coords)

    file.close()
    return a


def generate_list_of_filenames(path):
    a = []
    directory = os.listdir(path)
    for i in range(1,len(directory)+1):
        for filename in directory:
            number = str("l"+str(i)+".txt")
            if number in filename:
                a.append(filename)
    return a


def load_file_3D(filename, filepath, size):
    print("size:", size)
    complete_path = str(filepath+filename+"/")
    return load_object_3D(generate_list_of_filenames(complete_path), complete_path, size), load_platform_3D(str(filename+"_platform.txt"), complete_path, size)


def load_object_3D(filenames, path, size):
    m = []
    for f in filenames:
        fpath = str(path + f)
        m.append(load_object_2D(fpath, size))

    m_ut = []
    for i, line in enumerate(m):
        for point in line:
            point.append(i+1)
            m_ut.append(point)
    return m_ut

def load_platform_3D(f, path, size):
    p = []
    fpath = str(path + f)
    p.append(load_platform_2D(fpath, size))

    p_ut = []
    for i, line in enumerate(p):
        for point in line:
            point.append(i)
            p_ut.append(point)
    return p_ut

