import convex_front_advancing as cfa
import matplotlib
import matplotlib.pyplot as plt
import fileprocessing as fp
import plot2d
import plot3d



filename = "object6"
filepath = "Objects/3D/"
nd = 3
method = "greedy"


growing_field, shadowed_voxels = cfa.convex_front_advancing(nd, method, filename, filepath)

print("Layers successfully generated!")

matplotlib.use("TkAgg")  # to disable sciview
print("plotting ...")
if nd == 2:
    plt.figure(figsize=(5,5))
    plt.axis([0, 16, 0, 16])
    plt.xlabel("x")
    plt.ylabel("z")

    obj, pl = fp.load_file(nd, filename, filepath)
    plot2d.object(obj, "k", "o", 20)
    plot2d.object(pl, "blue", "s", 160)

    plot2d.result(growing_field)
    plot2d.shadowed(shadowed_voxels)
    plt.show()

if nd == 3:
    #x0, x1, y0, y1, z0, z1 = 9, 27, 9, 27, 0, 16 # large platform'
    x0, x1, y0, y1, z0, z1 = 0, 16, 0, 16, 0, 16 # medium platform

    ax = plot3d.setup(x0,x1, y0,y1, z0,z1)
    plot3d.result(ax, growing_field, point_size=30, point_shape="s")
    if len(shadowed_voxels) > 0:
        plot3d.points(ax, shadowed_voxels, point_size=5, shape="x", color="red")
    plt.show()
