import matplotlib.pyplot as plt
import numpy as np
from mpl_toolkits import mplot3d
import utilities as ut


def setup(x0,x1, y0,y1, z0,z1):
    fig = plt.figure()
    axis = fig.add_subplot(projection='3d')
    axis.set_xlabel('x')
    axis.set_ylabel('y')
    axis.set_zlabel('z')
    axis.set_xlim(x0,x1)
    axis.set_ylim(y0,y1)
    axis.set_zlim(z0,z1)
    return axis


def points(axis, points, point_size, shape, color):
    v = np.asarray(points)
    axis.scatter3D(v[:,0], v[:,1], v[:,2], alpha=1, marker=shape, s=point_size, c=color, edgecolors="k")



#help from: https://stackoverflow.com/questions/27270477/3d-convex-hull-from-point-cloud
def hull(axis, model, hull, color):
    points = np.asarray(model)
    for i, simplex in enumerate(hull.simplices):
        simplex = np.append(simplex, simplex[0]) #Here we cycle back to the first coordinate
        axis.plot(points[simplex,0], points[simplex,1], points[simplex,2], c=color)


def result(ax, field, point_size, point_shape):
    colors = ut.get_array_of_colors()
    for i, layer in enumerate(field):
        points(ax, layer, point_size, point_shape, colors[i])
